#include "MCP41.h"


void MCP41_init (void)
{
	/*configure SPI*/
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0);
	/*configure DDRx*/
	MCP41_DDR = (1<<MCP41_CS) | (1<<MCP41_SS) | (1<<MCP41_MOSI) | (1<<MCP41_SCK);
	MCP41_PORT = (1<<MCP41_CS) | (1<<MCP41_SS);
}


void MCP41_set_value (unsigned char byte)
{
	MCP41_init ();
	/*select device*/
	MCP41_PORT &= ~(1<<MCP41_CS);
	/*poti 0 MCP41dressed*/
	SPDR = 0b00010001;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	SPDR = byte;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	MCP41_PORT |= (1<<MCP41_CS);
}

void MCP_41_shutdown (void)
{
	MCP41_init ();
	/*select device*/
	MCP41_PORT &= ~(1<<MCP41_CS);
	/*code for shutdown, poti 0 MCP41ressed*/
	SPDR = 0b00100001;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	/*dummy byte, ignored by poti*/
	SPDR = 0xFF;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	/*deselect device*/
	MCP41_PORT |= (1<<MCP41_CS);
}
